#!/usr/bin/perl

my %filehash = ();

while (<>) {
	chomp;
	if (/^\@magicreffile{(.*)}$/) {
		$gfile = $1;	
		next;
	}
	while (/(.*)\@magicref{(.*?)}(.*)/) {
		my ($start, $ref, $end) = ($1, $2, $3);
		print $start;


		my $file;
		if (!defined($gfile)) {
			$file = shift(@refcomps);
		} else {
			$file = $gfile;
		}
		if (!defined($filehash{$file})) {
			open(FILE, "$file") || die "Can not open $file: $!\n";
			@{$filehash{$file}} = <FILE>;
			close(FILE);
		}

		my @refcomps = split(/,/, $ref);
		my @reflines = ();
		for my $comp (@refcomps) {
			my $complen = length($comp);
			my $i = 0;
			my $pushed = 0;
			foreach $line (@{$filehash{$file}}) {
				$i++;
				if ($comp eq substr($line, 0, $complen)) {
					push(@reflines, $i);
					$pushed++;	
				}
			}
			if (!$pushed) {
				printf STDERR "Undefined \@magicref: $comp\n";
				push(@reflines, "??");
			}
		}
		@reflines = sort { $a <=> $b } (@reflines);
		for (my $i = 0; $i <= $#reflines; $i++) {
			my $j = $i;
			my $start = $i;

			while (($j + 1 <= $#reflines) && ($reflines[$j] + 1 == $reflines[$j + 1])) { $j++; }
			if ($j > $i) {
				splice(@reflines, $start, $j - $start + 1, $reflines[$start] . "--" . $reflines[$j]);
			}
		}
		print join(",", @reflines);
		
		$_ = $end;
	}
	if (/\@magicref{/) {
		die "There is a \@magicref, without proper closure at $.\n";
	}
	print "$_\n";
}
